#!/usr/bin/perl

#######################################################
# This script will display the current environment in the
# browser.
#######################################################

use Cwd;
use CGI;

my $cwd = cwd();
my $cgi = CGI->new();
print $cgi->header;

print <<EOM
<html>
<head><title>Print environment</title></head>
<body>
Displaying the environment.<br />
Perl version is: $]<br />
Working directory is: $cwd<br/>
\@INC is: @INC<br /><br />
EOM
;

print "<table border=1 cellpadding=1>";
my @keys = sort(keys(%ENV));


foreach my $key (@keys) {
  print "<tr><td>$key</td><td>$ENV{$key}</td></tr>\n";
}

print "</table></body></html>\n";
