// Color functions
function Color() {
    this.name = arguments[0] ;
    this.value = arguments[1] ;
}
// ColorScheme functions
function ColorScheme() {
    this.id = arguments[0] ;
    this.name = arguments[1] ;
    this.Colors = new Array() ;
    for (var i=2 ; i < arguments.length ; i++) {
        this.Colors[this.Colors.length] = arguments[i] ;
    }
    
    this.get_as_option = ColorScheme_get_as_option ;
    this.apply = ColorScheme_apply ;
}

function ColorScheme_get_as_option() {
    var output = "" ;
    output += "<option value='"+this.id+"'>"+this.name+"</option>" ;
    return output ;
}

function ColorScheme_apply() {
    for (var i=0; i < 4 ; i++) {
        field = document.forms[0]['color'+(i+1)] ;
        if (this.Colors[i] != null) {
            pickColor(this.Colors[i].value) ;
        }
    }
}

// ColorSchemeList functions
function ColorSchemeList() {
    this.id = arguments[0] ;
    this.name = arguments[1] ;
    this.ColorSchemes = new Array() ;
    for (var i=2 ; i < arguments.length ; i++) {
        this.ColorSchemes[this.ColorSchemes.length] = arguments[i] ;
    }
    
    this.add_scheme = ColorSchemeList_add_scheme ;
    this.show_dropdown = ColorSchemeList_show_dropdown ;
    this.on_change = ColorSchemeList_on_change ;
    this.get_scheme = ColorSchemeList_get_scheme ;
    this.get_control = ColorSchemeList_get_control ;
}

function ColorSchemeList_add_scheme() {
    if (arguments[0] != null) {
        this.ColorSchemes[this.ColorSchemes.length] = arguments[0] ;
    }
}

function ColorSchemeList_show_dropdown() {
    var output = "" ;
    output += "<select name='"+this.name+"' id='"+this.id+"' onChange=\"javascript:parent."+this.name+".on_change();\">" ;
    for (var i=0; i < this.ColorSchemes.length ; i++) {
        var scheme = this.ColorSchemes[i] ;
        output += scheme.get_as_option() ;
    }
    output += "</select>" ;
    document.writeln(output) ;
}

function ColorSchemeList_get_control() {
    return eval("document.forms[0]."+this.name+"") ;
}

function ColorSchemeList_on_change() {
    var control = this.get_control() ;
    if (control != null) {
        var selectedIndex = control.selectedIndex ;
        var scheme_id = control.options[selectedIndex].value ;
        this.get_scheme(scheme_id).apply() ;
    }
}

function ColorSchemeList_get_scheme() {
    var scheme_id = (arguments[0] != null) ? arguments[0] : 0 ;    
    for (var i=0 ; i < this.ColorSchemes.length ; i++) {
        var scheme = this.ColorSchemes[i] ;
        if (scheme.id == scheme_id) {
            return scheme ;
        }
    }
    return this.ColorSchemes[0] ;
}

