###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package ErrorHandling;

use strict;

use CGI qw(:standard);
use MetadotConfig;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;

    my $self = {};

    bless ($self, $class);


    return $self;
}

# classwide method
sub printError {
    my $self = shift;
    my $em=shift;

    print header();
#    # XXX
#    my $p = Gizmo->new();
#    $p->print_http_header;
    print<<EOF;
<html>
<body bgcolor="#ffffff">
    <br /><br /><br /><center>

        <table border="0" bgcolor="#000000" cellpadding="0" cellspacing="0">
        <tr>
        <td>
            <table border="0" width="100%" cellpadding="5" cellspacing="1">
            <tr>
                        <td bgcolor="#ffefd5" width="100%">
                <br /><font color="#ff0000"><b>Error -</b></font>
                <BLOCKQUOTE>$em<br /><br /><br /></BLOCKQUOTE>
                    <b>Please contact your system administrator if this error persists.</b><br /><br /><br /></td>
                    </tr>
                        </table>
                        </td>
                            </tr>

                            </table>
                                </center>
  </body>
</html>
EOF

    exit(-1);
}

1;


__END__

=head1 NAME

ErrorHandling -

=head1 SYNOPSIS

    use ErrorHandling;
    ErrorHandling->printError($errormsg);

=head1 DESCRIPTION

=cut
