package Gizmo3000::HelloWorld::HelloWorld3000;

=head1 NAME

Gizmo3000::HelloWorld::HelloWorld3000

=head1 VERSION

Version $Revision: 1.1 $

=head1 DESCRIPTION

HelloWorld3000 is a minimal subclass of Gizmo3000 primarily used for testing.

=cut


use strict;
use vars qw(@ISA);

use Metadot::Gizmo3000;
@ISA = qw(Metadot::Gizmo3000);

use constant GIZMO_CONFIG => {
    GIZMO_INFO   => {
        name                => 'Hello World',
        version             => '$Revision: 1.1 $',
        description         => 'A minimal Gizmo3000 for testing',
        author              => 'Cory Kim',
        info                => 'www.metadot.com',
        need_portal_version => 6.4,
        debug               => 4,
        edit_help           => 'blablablah',
        allowed_containers  => [],  #don't appear in add-child lists
    },
    GIZMO_FIELDS  => [
        {
            name            => 'hello_name',
            label           => 'Hello Name',
            is_mandatory    => 1,
            inline_help     => 'The object of our greeting, as in: "Hello, name!"',
            store_at_column => 'name',
        },
    ],
};




sub do_show {
    my $self    = shift;
    my $context = shift;
    
    # You could output HTML directly here, or provide the name of a template.
    return 'HelloWorld/hello.tt2';
}




1;
