###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package md_h_applist;
use GizmoTag;
@ISA = ("GizmoTag");
use Gizmo::Category;
use Gizmo::Application;
use strict;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new();
    $self->{name} = 'md_h_applist';
    $self->{version} = '$Revision: 5.11.40.2 $';
    $self->{authorname} = 'Mirko Scavazzin';
    $self->{email} = 'mirko@metadot.com';
    $self->{url} = 'http://www.metadot.net/';
    $self->{license} = '';
    $self->{styleclass} = 'tagHAppListClass';
    $self->{description} = 'display horizontally the applications list';
    bless ($self, $class);
    return $self;
}

sub md_tag_exec {
  my $self = shift;
  my $myiid = shift;
  # removed hard-code of Category; this causes probs with instance cache.
  return "<div class='" . $self->get_styleclass() . "'>" . Application->show_application_bar() . "</div>";
}

1;

