# $Id: md_subnav.pm,v 1.1 2002/11/25 14:41:27 yuri
###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package md_subnav;
use GizmoTag;
@ISA = ("GizmoTag");

use Metadot qw($PARAMS);

use strict;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new();
    $self->{name} = 'md_subnav';
    $self->{version} = '$Revision: 5.13.30.2 $';
    $self->{authorname} = 'Yuri Gritzenko';
    $self->{email} = 'yuri@metadot.com';
    $self->{url} = 'http://www.metadot.net/';
    $self->{license} = '';
    $self->{styleclass} = '';
    $self->{description} = 'display printer_friendly and email_friend icon';
    bless ($self, $class);
    return $self;
}

sub md_tag_exec {
    my $self = shift;
        my $iid = shift;
    my $isa = "Category";
    my $imglocation = $PARAMS->{imageslocation};
        my $str = "
<br /><br />
<a href='index.pl?isa=$isa&amp;op=show_printer_friendly&amp;iid=$iid' target='_blank'>
<img align='absmiddle' src='$imglocation/obj/printer_icon.gif' alt='Printer Friendly Version' border='0'>
</a>
<a href='index.pl?isa=$isa&amp;op=invite&amp;iid=$iid'>
<img align='absmiddle' src='$imglocation/obj/mail_icon.gif' alt='Email This To Your Friend' border='0'>
</a>
";
        return $str;
}

1;

