#!/usr/bin/perl -w
#
###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################

package EmailFriend;
use strict;

use Metadot qw(%FORM $PARAMS $USER $DISPLAY $SESSION);
use ErrorHandling;
use Sendmail;

# This module is obsolete.

# sub new {
#     my $proto = shift;
#     my $class = ref($proto) || $proto;
#     my $self = {};
#         $self->{err_str} = "";
#     bless ($self, $class);
#     return $self;
# }
#
# sub set_err_str {
#     my $self = shift;
#         my $str = shift;
#     $self->{err_str} .= $str;
# }
#
# sub get_err_str {
#     my $self = shift;
#     return $self->{err_str};
# }
#
# sub www_show_email_friend {
#       my $self = shift;
#         my $name = $self->{name};
#       my $content = "<br /><h2>Email page to a friend:</h2>Page Name: <b>$name</b><br /><br />";
#       my $sent = $self->process_email_friend();
#       if ($sent) {
#         $content .= $self->get_success_page(); # show success page
#     }
#       else {
#                 if ($self->get_err_str()) {
#                    $content .= "<font color='red'>Please correct the following errors:<br /><br />";
#                      $content .=  $self->get_err_str() . "</font>" ;  # show error block
#                      $content .= $self->get_email_form();                           #  and show form
#                      $DISPLAY->print_simple_layout({content =>$content});
#                 }
#                 else {
#                      $content .= $self->get_email_form();# show email friend form
#                      $DISPLAY->print_simple_layout({content =>$content});
#                 }
#     }
#
#     return 1;
# }
#
# sub process_email_friend {
#     my $self = shift;
#         my $send = $FORM{send};
#         if ($send ne '1') { return 0; }
#         my $id = $self->defined_or_exit($self->id,"id is missing.");
#
#         # get form input:
#         my $to_name = $FORM{'to_name'};
#         my $to_email = $FORM{'to_email'};
#         my $from_name = $FORM{'from_name'};
#         my $from_email = $FORM{'from_email'};
#         my $type = $FORM{'type'};
#         my $subj = $FORM{'subj'};
#         my $msg = $FORM{'msg'};
#         my $cc = $FORM{'cc'};
#
#         # check entered email adr. and 'from' and 'to' names:
#         if ( !($self->check_email_adr($to_email)) ) {
#           $self->set_err_str('"To" email address is not valid.<br />');
#         }
#         if ( !($self->check_email_adr($to_email)) ) {
#           $self->set_err_str('"From" email address is not valid.<br />');
#         }
#         if (!($to_name)) {
#           $self->set_err_str('"To" name should not be blank.<br />');
#         }
#         if (!($from_name)) {
#           $self->set_err_str('"From" name should not be blank.<br />');
#         }
#
#         # break if error:
#         if ($self->get_err_str) {
#              return 0;
#         }
#
#         # define subject:
#         my $basename = $PARAMS->{basename} ;
#         my $hostname = $basename;
#         $hostname =~ s/\/metadot// ; # retrieving hostname as 'www.yourname.com'
#         $hostname =~ s/http:\/\/// ;
#         my $link = $basename . "/index.pl?iid=$id";   # $PARAMS->{uri_scheme} . "://" .
#         my $link_html = "<a href='$link'>$link</a>" ;  # html link
#
#         # convert message
#         $msg =~ s/\n/<br \/>/g;
#
#         # define body
#         if ($type eq 'full') {
#              # WARNING !  Changing the relative image path to absolute #
#              # This is temporary solution of the problem #
#              # It should be change back below
#              my $img_loc_rel = $PARAMS->{imageslocation} ;
#              $PARAMS->{imageslocation} = "http://" . $hostname . $img_loc_rel ;
#              #ErrorHandling->printError("$s");
#
#              my ( $news_col, $poll_col, $cal_col, $content_col, $style_sheet );
#              if( $SESSION->admin_mode() ) {
#                      $SESSION->edit_off();
#                      ( $news_col, $poll_col, $cal_col, $content_col, $style_sheet ) =
#                  ( $self->show_news_column(),
#                  $self->show_poll_column(),
#                  $self->show_calendar_column('', $id, 'show'),
#                  $self->show_simple(),
#                  $DISPLAY->show_style_sheet() );
#
#                      $SESSION->edit_on();
#
#          } else {
#
#                      ( $news_col, $poll_col, $cal_col, $content_col, $style_sheet ) =
#                  ( $self->show_news_column(),
#                  $self->show_poll_column(),
#                  $self->show_calendar_column('', $id, 'show'),
#                  $self->show_simple(),
#                  $DISPLAY->show_style_sheet() );
#          }
#
#          my $right_col = "
# <!-- News column -->
# <td align='right' valign='top' width=\"155\">
# $cal_col
#
# $news_col
#
# $poll_col
# </td>
# <!-- End of News column -->
# ";
#
#       $msg = <<"END_TOK";
# <html>
# <head>
# $style_sheet
# </head>
# <body bgcolor="white">
#
# <!-- Outer Table -->
# <table border="0" cellspacing="10" cellpadding="10" width="600">
# <tr><td>
# <!-- User Message -->
# $msg
# <br /><br />
# <a href="index.pl?iid=$id">$link</a>
# <!-- Category Table -->
# <table border="0" cellpadding="0" cellspacing="10" width='100%'>
# <tr>
# <!-- Category column -->
# <td valign='top' width="100%">
# $content_col
# </td>
# <!-- End of Category column -->
# $right_col
# </tr></table>
# <!-- End of Category Table -->
#
# </td></tr></table>
# <!-- End of Outer Table -->
# </body></html>
# END_TOK
#
#              # changing <a href > and <img src > to absolute:
#              $msg =~ s/href ?= ?(['"])\/?/href=$1$basename\//gi ;
#              $msg =~ s/img src ?= ?(['"])\.\.\/?/img src=$1http:\/\/$hostname\//gi ;
#              $msg =~ s/img src ?= ?(['"])index/img src=$1$basename\/index/gi ;
#              $PARAMS->{imageslocation} = $img_loc_rel;
#              }
#
#         # Send link only
#         if ($type eq 'link')  {
#           $msg .= "<br /><br />$link_html";
#         }
#
#         # cc defined ?
#         if ($cc eq '1') { $cc = $from_email}  else { $cc = ""; }
#
#         # sending mail:
#     my $sm = Sendmail->new($to_email, $cc, "", $subj, $msg);
#         $sm->set_from($from_email);
#         $sm->set_content_type('html');
#         return $sm->sendMail();
# }
#
#
# sub get_email_form {
#   my $self = shift;
#     my $isa = $self->is_a;
#     my $iid = $self->defined_or_exit($self->id,"id is missing.");
#     my $uid ;
#     my $from_name ;
#     my $from_email ;
#     my $basename = $PARAMS->{basename} ;
#     my $mailsender = $PARAMS->{mailsenderaddress} ;
#     my ($pr,$mailserver) = split /\@/,$mailsender ;
#     my $hostname = $basename;
#     $hostname =~ s/\/metadot// ; # retrieving hostname as 'www.yourname.com'
#     $hostname =~ s/http:\/\/// ;
#     my $link = $basename . "/index.pl?iid=$iid";
#     my $default_msg = "Hello, I think you would be interested in this web page.\n";
#     my $to_name = $FORM{'to_name'};
#     my $to_email = $FORM{'to_email'};
#     my $type = $FORM{'type'};
#     my $msg = $FORM{'msg'} || $default_msg;
#     my $cc = $FORM{'cc'};
#     my $subj = $hostname . " page: ". $self->{name};
#     my $disable = '';
#
#     # get prefill data
#     my $logged_in_count = $USER->is_logged_in() || 0;
#     if ( $logged_in_count >= 1) {  # if logged in
#        $uid = $USER->{uid} ;
#          $from_name  = $USER->webname();
#          $from_email = $USER->get_email_from_uid ($uid);
#          if ( !($self->check_email_adr($from_email)) ) { $from_email .= "\@".$mailserver; }
#          $disable = "disabled";
#     }
#
#     $from_name = $FORM{'from_name'} || $from_name;
#     $from_email = $FORM{'from_email'} || $from_email;
#
#   my $str = "
# <br />
# <table cellspacing='0'>
# <form action='index.pl' method='post'>
# <tr>
# <th></th><th>Friend's</th>
# <th></th><th>Your</th>
# </tr>
# <tr>
# <td>Name:</td><td><input type='text' name='to_name' size='20' value='$to_name' ></td>
# <td>Name:</td><td><input type='text' name='from_name' size='20' value='$from_name'></td>
# </tr>
# <tr>
# <td>E-mail:</td><td><input type='text' name='to_email' size='20' value='$to_email'></td>
# <td>E-mail:</td><td><input type='text' name='from_email' size='20' value='$from_email' $disable></td>
# </tr>
# <tr>
# <td>Subject:</td><td colspan='3'><input type='text' name='subj' size='52' value='$subj'></td>
# </tr>
# <tr>
# <td>Message:</td><td colspan='3'><textarea rows='5' cols='35' name='msg'>$msg
# </textarea></td>
# </tr>
# <tr>
# <td>Format:</td>
# <td colspan='3'><input type='radio' name='type' value='link' checked='checked' tabindex='1' >
#  Send <strong>link</strong> to story only &nbsp;
# <input type='radio' name='type' value='full' tabindex='2'>
#   Send <strong>full text</strong> of story</td>
# </tr>
# <tr>
# <td></td><td colspan='3'><input type='checkbox' name='cc' value='1' checked>
#  Send me a copy &nbsp;&nbsp;<input type='submit' value='Send Story'>
#  <input type='hidden' name='send' value='1'>
#  <input type='hidden' name='isa' value='$isa'>
#  <input type='hidden' name='op' value='show_email_friend'>
#  <input type='hidden' name='iid' value='$iid'>
#  </td>
# </tr>
# </table>
# </form>
# ";
#
#     return $str;
# }
#
# sub get_success_page {
#   my $self = shift;
#     my $to = $FORM{'to_email'};
#     my $id = $self->defined_or_exit($self->id,"id is missing.");
#   $DISPLAY->print_choices( "
#     Your email has been sent to $to",
#      'readme', "Continue", "index.pl?id=$id
# " );
# }
#
#
# sub check_email_adr {
#   my $self = shift;
#     my $email = shift;
#   if ($email =~ m/.*@.*\..*/) {
#          return 1 ;
#     }
#     else  {
#          return 0;
#     }
#
# }

1;
