###########################################################################
# $Id: FormDataObj.pm,v 5.10.40.3 2005/11/10 15:25:24 nico Exp $
#
###########################################################################
###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package Metadot::FormDataObj;

#========================================
#========================================

use strict;
use Data::Dumper;

#constructor
# sub new {
#     my $proto = shift;
#     my $class = ref($proto) || $proto;
#     my $self = {};

#     bless ($self, $class);
#     return $self;
# }

sub getDataInfo {
    my ($class, $dataobj, $form_elt_hash) = @_;

    #print STDERR "in FormDataObj->getDataInfo, with form elt hash ", Dumper($form_elt_hash), "\n";
    my $col_info_hash = {};
    foreach my $key (%$form_elt_hash) {
    if (exists $dataobj->{$key}) {
        my $value = $dataobj->{$key};
        my $col_info = { 'value' => $value};
        $col_info_hash->{$key} = $col_info;
    }
    }
    return $col_info_hash;
}

# this is a 'no-op' for now
sub getFieldInfo {
    my ($class, $dataobj, $form_elt_hash) = @_;
    my $col_info_hash = {};
    return $col_info_hash;
}


1;
