###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server
# Copyright (C) 2001 Metadot Corporation
#
# For more information go to
# http://www.metadot.com
# or contact us at info@metadot.com
#
#</LICENSEINFO>
############################################################################

# An interface to specify that a gizmo supports the 'Show Printer Friendly'  option.

package Metadot::Printable;

use strict;

sub customize_permissions {
    my $class = shift;
    my $perms = shift || Operations->new();
    $perms->add_op('DISP', 'show_printer_friendly');

    return $perms;
}

sub www_show_printer_friendly {
    die("Abstract method");
}


# for the MetadotController. You should implement a mapping for this response.
sub exec_show_printer_friendly {
    my $self = shift;
    return 'show_printer_friendly';
}


1;
