###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################

package Metadot::Skin;

use strict;
use vars qw(@ISA);

use MetadotObject;
@ISA = qw(MetadotObject);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my @args = @_;

    my $self = $class->SUPER::new(@args);

    bless $self, $class;
    return $self;
}


use constant MO_INSTANCE_PROPERTIES => {
    id          => '',
    name        => '',
    short_name  => '',
    author      => '',
    revision    => '',
    website     => '',
    description => '',
    license     => '',
    read_only   => 'false',
    based_on    => '',
};


########################################################
#
# Accessors and mutators
#
########################################################

sub is_read_only {
    my $self = shift;
    my $read_only_value = $self->get_read_only();
    return ( $read_only_value && lc($read_only_value) ne 'false');
}








1;
