###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################






############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
#
# Note: this class is deprecated. Most of its functionality has been
#       absorbed into FlexUser.
#
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################
############################################################################





































package Metadot::User::FlexUserWithGroups;
use strict;

use Data::Dumper;
#use Storable;  # no longer used

use Metadot qw($USER %FORM $SESSION $HTTP_HEADER_SENT $PARAMS $CACHE $CGI $ACCESS_BROKER $DISPLAY);
use Metadot::DataCollection;
use Metadot::UserFactory;
use Metadot::RegisterFactory;
use Metadot::Register::FlexRegisterWithGroups;

use Metadot::User::FlexUser;
use vars qw(@ISA);
@ISA=qw(Metadot::User::FlexUser);

## aju - clone bundle before pushing new stuff onto it.
my $FAC;
sub get_AC {
    my $ac = Metadot::User::FlexUser->get_AC();
    if( defined $FAC ) {
        return $FAC;
    }
    my $copy_ac = Storable::dclone(Metadot::User::FlexUser->get_AC());
#     push( @{ $FAC->{BUNDLES}{MOD}{OPS} }, 'show_group_users' );
    ## neccesary to delete OPS key from parent
    delete($copy_ac->{OPS});
    $FAC = Operations->new($copy_ac);
    $FAC->add_op('MOD', 'show_group_users');

    return $FAC;
}
#sub get_AC { return $FAC; }

my $shipping_address_html = "
<script language='JavaScript'>
function findInput(strInputName) {
    for (var i=0; i < document.forms.length; i++) {
        var field = eval(\"document.forms[\"+i+\"].\"+strInputName);
        if (field != null) {
            return field;
        }
    }
    return null;
}
function setMailingAddress() {
    findInput('ship_address_line_1').value = findInput('address_line_1').value;
    findInput('ship_address_line_2').value = findInput('address_line_2').value;
    findInput('ship_city').value = findInput('city').value;
    findInput('ship_state').value = findInput('state').value;
    findInput('ship_zip_code').value = findInput('zip_code').value;
    findInput('ship_country').value = findInput('country').value;
}
</script>
(Do not use P.O. Box)<br />
<input type='button' value='Same as mailing' name='same' onClick='javascript:setMailingAddress();'>
";

my $allied_help = "<font color=\"red\"><a href=\"/public/allied_account_info.html\" target=\"_blank\">Click here</a> to obtain list for your facility's Allied seven (7) digit account number for manual entry.</font>";
my $topics_help = "For a complete description of each topic category, <a href=\"/public/topics_info.html\" target=\"_blank\">click here</a>.";

my $FIELDS_CONFIG = {
                DISPLAY_SETS => [ 'Login Information', 'Contact Information', 'Company Information', 'Mailing Address',
                  'Shipping Address', 'Select Topics of Interest', '' ],
             # appended after the set name
DISPLAY_SETS_ADDITIONAL_HTML => [ '',  '', $allied_help, '', $shipping_address_html, $topics_help],
             FIELDS => [
# Login Information
                {
                 field_name => 'first_name',
                 description => 'First Name',
                 max_length => 64,
                 size => 20,
                 is_required => 1,
                 display_set => 0,
                 storage_type => 'secondary',
                 store_at_column => "f1",
                 verify_type => 'non_empty',
                },
                {
                 field_name => 'initial',
                 description => 'Middle Initial',
                 max_length => 1,
                 size => 1,
                 is_required => 0,
                 is_not_required_for_default_users => 1,
                 display_set => 0,
                 storage_type => 'secondary',
                 store_at_column => "f2",
                },
                {
                 field_name => 'last_name',
                 description => 'Last Name / Family Name',
                 max_length => 64,
                 size => 20,
                 is_required => 1,
                 is_not_required_for_default_users => 1,
                 display_set => 0,
                 storage_type => 'secondary',
                 store_at_column => "f3",
                },
                {
                 field_name => 'nickname',
                 description => 'Nickname / Screenname',
                 max_length => 64,
                 size => 20,
                 is_required => 0,
                 display_set => 0,
                 storage_type => 'primary',
                },
                {
                 field_name => 'email',
                 description => 'E-mail Address',
                 max_length => 64,
                 size => 20,
                 is_required => 1,
                 display_set => 0,
                 storage_type => 'primary',
                },
                {
                 field_name => 'password',
                 description => 'Password',
                 max_length => 64,
                 size => 20,
                 is_required => 1,
                 display_set => 0,
                 storage_type => 'primary',
                 field_type => 'password',
                },
# Company Information
                {
                 field_name => 'allied_account_number',
                 description => 'Allied Account #',
                 max_length => 64,
                 size => 36,
                 is_required => 0,
                 display_set => 2,
                 storage_type => 'secondary',
                 store_at_column => "f19",
                },
                {
                 field_name => 'group',
                 field_type => 'group',
                 description => 'Group',
                 is_required => 1,
                 display_set => 2,
                 storage_type => 'secondary',
                 store_at_column => "f14",
                },
                {
                 field_name => 'region',
                 field_type => 'dependent',
                 controlling_field => 'group',
                 description => 'Region',
                 is_required => 1,
                 display_set => 2,
                 storage_type => 'secondary',
                 store_at_column => "f15",
                },
                {
                 field_name => 'job_title',
                 description => 'Job Title',
                 max_length => 64,
                 size => 36,
                 is_required => 1,
                 display_set => 2,
                 storage_type => 'secondary',
                 store_at_column => "t1",
                },
# Mailing Address
                {
                 field_name => 'plant_name',
                 description => 'Company Name',
                 max_length => 64,
                 size => 36,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "f16",
                },
                {
                 field_name => 'address_line_1',
                 description => 'Address Line 1',
                 max_length => 64,
                 size => 36,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t4",
                },
                {
                 field_name => 'address_line_2',
                 description => 'Address Line 2',
                 max_length => 64,
                 size => 36,
                 is_required => 0,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t5",
                },
                {
                 field_name => 'city',
                 description => 'City',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t6",
                },
                {
                 field_name => 'state',
                 description => 'State',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t7",
                },
                {
                 field_name => 'zip_code',
                 description => 'Zip Code',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t8",
                },
                {
                 field_name => 'country',
                 description => 'Country',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 3,
                 storage_type => 'secondary',
                 store_at_column => "t9",
                },
# Shipping Address
                {
                 field_name => 'ship_address_line_1',
                 description => 'Address Line 1',
                 max_length => 64,
                 size => 36,
                 is_required => 1,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f4",
                },
                {
                 field_name => 'ship_address_line_2',
                 description => 'Address Line 2',
                 max_length => 64,
                 size => 36,
                 is_required => 0,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f5",
                },
                {
                 field_name => 'ship_city',
                 description => 'City',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f6",
                },
                {
                 field_name => 'ship_state',
                 description => 'State',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f7",
                },
                {
                 field_name => 'ship_zip_code',
                 description => 'Zip Code',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f8",
                },
                {
                 field_name => 'ship_country',
                 description => 'Country',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 4,
                 storage_type => 'secondary',
                 store_at_column => "f9",
                },
# Contact Information
                {
                 field_name => 'telephone',
                 description => 'Telephone',
                 max_length => 64,
                 size => 30,
                 is_required => 1,
                 display_set => 1,
                 storage_type => 'secondary',
                 store_at_column => "f10",
                },
                {
                 field_name => 'fax',
                 description => 'Fax',
                 max_length => 64,
                 size => 30,
                 is_required => 0,
                 display_set => 1,
                 storage_type => 'secondary',
                 store_at_column => "f11",
                },
                {
                 field_name => 'mobile_phone',
                 description => 'Mobile Phone',
                 max_length => 64,
                 size => 30,
                 is_required => 0,
                 display_set => 1,
                 storage_type => 'secondary',
                 store_at_column => "f12",
                },
# 10-21-02 took out @ Paul's request...
#               {
#                field_name => 'pager_phone',
#                description => 'Pager Phone',
#                max_length => 64,
#                size => 30,
#                is_required => 0,
#                display_set => 1,
#                storage_type => 'secondary',
#                store_at_column => "f13",
#               },
#               {
#                field_name => 'pager_number',
#                description => 'Pager Address',
#                max_length => 64,
#                size => 30,
#                is_required => 0,
#                display_set => 1,
#                storage_type => 'primary',
#               },
#               {
#                field_name => 'icq_number',
#                description => 'ICQ Number',
#                max_length => 64,
#                size => 20,
#                is_required => 0,
#                display_set => 1,
#                storage_type => 'primary',
#               },
# Select Topics of Interest
                {
                 field_name => 'groups_of_interest',
                 field_type => 'checkbox_group',
                 description => 'For the topics that you select, you may receive periodic notifications of interest. You can re-edit your profile at any time to add or delete topics.',
#                max_length => 64,
                 max_lines => 7,
                 is_required => 0,
                 display_set => 5,
                 storage_type => 'secondary',
                 store_at_column => "f17",
                },
# User Agreement
                {
                 field_name => 'user_agreement',
                 field_type => 'user_agreement',
                 agreement_url  => '/public/agreement.html',
                 agreement_desc => 'View User Agreement',
                 description => 'Before clicking the "submit" button, you must view the user agreement, and indicate your agreement with its terms.',
                 is_required => 1,
                 display_set => 6,
                 storage_type => 'secondary',
                 store_at_column => "f18",
                },
                   ],
            };

my $check_for_required_fields_done;

sub get_fields_config {
    my $self = shift;

    my $required_fields = [ qw( first_name last_name email password ) ];

    # we do this to trap any missing required fields from the
    # fields data structure
    unless( $check_for_required_fields_done ) {
        $check_for_required_fields_done++;
        foreach my $req_field ( @{ $required_fields } ) {
            my $found;
            foreach my $field ( @{ $FIELDS_CONFIG->{FIELDS} } ) {
                $found++ if ( $field->{field_name} eq $req_field );
            }
            unless( $found == 1 ) {
                die "fields configuration data structure does not contain field $req_field (or contains it more than once)";
            }
        }
    }

    return $FIELDS_CONFIG;
}

sub new {
    my $class = shift;

    my $self = $class->SUPER::new(@_);
    $self->_load_secondary_fields();

    return $self;
}

sub get_accounts_pending_collection {
    my $self = shift;
    my $user = shift || $USER;
    my $collection = Metadot::DataCollection->new();

    return $collection unless (defined $user);

    # get list of group ids where this user is a manager
    my @grp_ids = ();
    my $sth = DBAccess->sqlSelectMany("grp_id", "grpmembers", "is_manager=1 and userid=".$user->{uid});
    while (my ($grp_id) = $sth->fetchrow()) {
        push(@grp_ids, $grp_id);
    }

    return $collection unless (scalar @grp_ids > 0);

    # get count of user accounts in these groups that are waiting approval
    $sth = DBAccess->sqlSelectMany("users.userid", "users, grpmembers",
            "users.approvalneeded='required' and users.userid=grpmembers.userid and grpmembers.grp_id IN (".join(",", @grp_ids).")");
    while (my ($userid) = $sth->fetchrow()) {
        my $group_user = Metadot::UserFactory->get_user($userid);
        $collection->add($group_user);
    }

    return $collection;
}

sub get_num_accounts_pending_approval {
    my $self = shift;
    my $user = shift || $USER;

    return 0 unless (defined $user);
    return $self->SUPER::get_num_accounts_pending_approval() if ($ACCESS_BROKER->is_allowed_to_do('admin_tasks'));

    my $accounts_pending_collection = $self->get_accounts_pending_collection($user);

    return $accounts_pending_collection->data_array_length();
}

sub www_show_group_users {
    my $self = shift;
    my $user = shift || $USER;
    $self->debug_msg(3, "FlexUserWithGroups::www_show_group_users()");
    my $imageslocation = $PARAMS->{'imageslocation'};

    # for admin we just render the old interface
    return $self->SUPER::www_show_users(@_) if ($ACCESS_BROKER->is_allowed_to_do('admin_tasks'));
    my $collection = $self->get_accounts_pending_collection($user);

    $DISPLAY->print_http_header;

    my $all_url = "<a href='index.pl?id=0'>Home</a>";
    my $approved_text = "";
    my $rejected_text = "";

    # approve/reject users
    $collection->restart();
    my $registrator = Metadot::RegisterFactory->get_register();
    while (my $u = $collection->get_next()) {
        my $approval_needed = $u->approval_needed() || "";
        my $input_name = "approve_".$u->{uid};

        next unless (defined $FORM{$input_name});

        if ($FORM{$input_name} == 1) {
            $u->approval_needed("accepted");
            $u->save();
            $registrator->send_approval_message( $u, 'accepted' );
            $approved_text .= "<br />".$u->{fullname}." (".$u->email().")";
        } elsif ($FORM{$input_name} == 0) {
            $u->approval_needed("rejected");
            $u->save();
            $registrator->send_approval_message( $u, 'rejected' );
            $rejected_text .= "<br />".$u->{fullname}." (".$u->email().")";
        }
    }
    $approved_text = "<br /><br /><font color='#00AA00'>Approved Users:</font>".$approved_text if ($approved_text ne "");
    $rejected_text = "<br /><br /><font color='#AA0000'>Rejected Users:</font>".$rejected_text if ($rejected_text ne "");

    # render the list of users
    print $self->show_top($FORM{iid});
    print $self->show_title("Users Awaiting Approval");
    print "<br />".$all_url."<br /><br />";

    print "<form action='index.pl' method='post'>";
    print "<input type='submit' name='approval' value='Submit'>";
    print "<input type='hidden' name='iid' value='".$FORM{iid}."'>";
    print "<input type='hidden' name='isa' value='User'>";
    print "<input type='hidden' name='op' value='show_group_users'>";
    print "<input type='hidden' name='pending' value='true'>";
    print $approved_text;
    print $rejected_text;
    print "<br />";
    print "<br />";
    print "<table border=\"1\">";
        print "<tr><th colspan='2'>Approval</th><th rowspan=2>User Information</th><th rowspan=2>Group</th><th rowspan=2>ID</th><th rowspan=2>Email address</th></tr>";
        print "<tr><th>Approve</th><th>Reject</th></tr>";
        $collection->restart();
        while (my $u = $collection->get_next()) {
            my $approval_needed = $u->approval_needed() || "";
            my $input_name = "approve_".$u->{uid};

            my $approval_string = "";
            if ($approval_needed eq "accepted") {
                $approval_string = "<font color='#00AA00'>(approved)</font>";
            } elsif ($approval_needed eq "rejected") {
                $approval_string = "<font color='#AA0000'>(rejected)</font>";
            }

            my $nickname = "";
            if ($u->{nickname}) {
                $nickname = "<I>(".$u->{nickname}.")</I>";
            }
        # extra stuff requested by Paul
        my $phone = "";
            if ($u->{telephone}) {
                $phone = $u->{telephone};
            }
        my $jtitle = "";
            if ($u->{job_title}) {
                $jtitle = $u->{job_title};
            }
        my $company = "";
            if ($u->{plant_name}) {
                $company = $u->{plant_name};
            }
        # use shipping address city.
        my $city = "";
            if ($u->{ship_city}) {
                $city = $u->{ship_city};
            }
        my $anumber = "";
            if ($u->{allied_account_number}) {
                $anumber = $u->{allied_account_number};
            }

            my ($hpiid) = $u->has_portal();
            my $portal = "&nbsp;";
            $portal = "<a href=\"".$self->make_url("index.pl?iid=$hpiid")."\">User Website</a>\n" if (defined $hpiid && $hpiid > 0);

            my $email = $u->{email} || "";
            $email = "<a href=\"mailto:$email\">$email</a>\n" if ($email);

            print "<tr>";
            if ($approval_string ne "") {
                print "<td colspan='2' align='center'>$approval_string</td>";
            } else {
                print "<td valign='top' align='center'><input type='radio' name='".$input_name."' value='1'></td>";
                print "<td valign='top' align='center'><input type='radio' name='".$input_name."' value='0'></td>";
            }
            print "<td>";
        print "<table border=\"0\">";
        print "<tr valign='baseline'><td align='right'><b>Name</b>:</td><td> ".$u->{fullname}." <br />".$nickname . "</td></tr>\n";
        print "<tr valign='baseline'><td align='right'><b>Phone</b>:</td><td>$phone</td></tr>\n";
        print "<tr valign='baseline'><td align='right'><b>Job Title</b>:</td><td>$jtitle</td></tr>\n";
        print "<tr valign='baseline'><td align='right'><b>Company</b>:</td><td> $company</td></tr>\n";
        print "<tr valign='baseline'><td align='right'><b>City</b>:</td><td> $city</td></tr>\n";
        print "<tr valign='baseline'><td align='right'><b>Allied Account Number</b>:</td><td> $anumber</td></tr>\n";
        print "</table>";
        print "</td>";
            print "<td valign='top'>" . $self->_get_user_registration_group($u) .
        "</td><td valign='top'>".$u->{uid}."</td>" .
        "<td valign='top'>".$email."</td>";
#              print "<td valign='top'>".$u->{uid}."</td><td valign='top'>".$portal."</td>" .
#       "<td valign='top'>".$email."</td>";
            print "</tr>";
        }
    print "</table>";
    print "<br />";
    print "<input type='submit' name='approval' value='Submit'>";
    print "</form>";
    print "\n\n<!-- End of Users -->\n\n";
    print $self->show_bottom();
}

sub _get_user_registration_group  {
    my $self = shift;
    my $u = shift;

    my $collection = Metadot::Register::FlexRegisterWithGroups->get_registration_group_collection();
    while (my $grp = $collection->get_next()) {
    if ((defined $u && $USER->belongs_to_grp($grp->{group_name}, $u->{uid}))) {
        return $grp->{group_name};
    }
    }
}

1;

