package Metadot::Utils::ParseExcel::Trimmer;

use strict;
use Data::Dumper;
use Utility;

sub hashTrim {
	my $class = shift;
	my $data = shift or die "Trimmer::hashTrim: Usage: hashTrim(\%data_hash)";
	
	my @keys = keys %$data;

	foreach my $key (@keys) {	
		$data->{$key} = $class->trim($data->{$key});
	}
	return $data;
}



sub trim {
	
	my $class = shift;
	my $str = shift or die "Trimmer::trim: Usage: trim(\$string)";

    return Utility->trim($str);
}
1;
