#!/usr/bin/perl -w

#######################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################


require Portal;

my $mdot = Portal->new(1, on_the_web=>0);

use SOAP::Transport::HTTP;



# Test if we are using mod-perl. We use a different transport class depending
# on if we are running mod_perl or straight CGI

eval {
  require Apache::Response;
};

my $transport_class;
if ($@) {
  $transport_class = 'SOAP::Transport::HTTP::CGI';
} else {
  $transport_class = 'SOAP::Transport::HTTP::Apache';
}

#print STDERR "Transport class: $transport_class\n";

$transport_class
  -> dispatch_to qw(Metadot::PortalFactory Metadot::Services::GizmoService)
  -> handle;

