var the_cookie = document.cookie ;
var today = new Date() ;

function days2msecs (days) {
    if (days != null && days >= 0) {
        return 24 * 60 * 60 * 1000 * days ;
    } else {
        return 0 ;
    }
}

function days2expiry (days) {
    return new Date(today.getTime()+days2msecs(days)) ;
}

// usage: setCookie('name_of_the_cookie', 'value_of_the_cookie' [, expiry_in_days]) ;
function setCookie(name, value) {
    var days = (arguments[2] != null) ? arguments[2] : 28) ;
    var expiry = days2expiry(days) ;
    if (value != null && value != "") {
        document.cookie = name + "=" + escape(value) + "; expires=" +
        expiry.toGMTString() ;
    }
    the_cookie = document.cookie ;
}

// usage: var cookie_value = getCookie('name_of_the_cookie') ;
function getCookie(name) {
    var index = the_cookie.indexOf(name + "=") ;
    if (index == -1) { return null ; }
    index = the_cookie.indexOf("=", index) + 1 ;
    var endstr = the_cookie.indexOf(";", index) ;
    if (endstr == -1) { endstr = the_cookie.length ; }
    return unescape(the_cookie.substring(index, endstr)) ;
}
