###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2005
#
# This file is part of Metadot Portal Server software $Name: Release_6_4_5_4 $
#
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package Metadot::FormProcessUID;

use strict;

use Metadotclass;
#  use DBAccess;

#  application-specific..

#  sub new {
#      my $proto = shift;
#      my $class = ref($proto) || $proto;
#      my $self = {};

#      bless ($self, $class);
#      return $self;
#  }

sub getUID {
    my ($class, $table, $pkey) = @_;
    my $mdc = Metadotclass->new();

    if ($table eq 'instance' && $pkey eq 'iid') {
    return $mdc->get_new_iid();
    }
    elsif ($table eq 'user' && $pkey eq 'uid') {
    return $mdc->get_uid();
    }
    elsif ($table eq 'channel' && $pkey eq 'cid') {
    return $mdc->get_cid();
    }
    else {
    return 'auto-increment';
    }
}


1;

