package Metadot::Implementations::Group::AbstractGroupImplementation;

use strict;

sub validate_or_refresh_cache {
    my $self = shift;
    my $impl = shift;
	die "Abstract method";
}

sub _show_view_groups_page {
    my $self = shift;
    my $impl = shift;
	die "Abstract method";
}

sub restore {
    my $self = shift;
    my $impl = shift;
   die "Abstract method";
}

# adds custom fields, both for adding and editing new groups
sub show_custom_form_fields {
    my $self = shift;
    my $implementor = shift;

# this is an abstract method. Here is a standard template for an input field:
#    <tr>
#        <td valign="top">Field Name</td>
#        <td><textarea name="group_description" rows="3" cols="20" wrap></textarea></td>
#    </tr>
    return '';
}

sub input_custom_form_fields {
    my $self = shift;
    my $impl = shift;
    my %properties = @_;

    # Abstract method: subclasses would modify %properties

    return %properties;
}

1;
